// reads TUP data from inTUP using in
// writes to newTUPout using nout
#include <iostream>
#include <iomanip>
#include <fstream>		// needed by  ofstream to open output file
#include "histogram.h"
#include <string>
#include <unistd.h>

#define DEBUG 0
#define DEBUG2 1

#define TAB '\t'

using namespace std;
 
unsigned  getbits( unsigned x, unsigned p, unsigned n)
{
    /* get n bits from position p */
        return  (( x >> (p+1-n)) & ~(~0 << n));
}


int main(int argc, char** argv)	{

	string titleString;

	int fileLineCount=0;
	int ntupleCount;                                                                                                                                          
	int eventCount;
	int ntupleInCount=0;
	int ntupleOutCount=0;
	int i;

	int adc1, adc2, tac1, tac2, tac3;

	float alim=0.0, blim=16384.0;
	histogram *hTAC1 = new histogram( alim, blim, "h time ADC TAC 1 data ");
	//	alim=1850.0; blim=1890.0; 
	histogram *hTAC2 = new histogram( alim, blim, "h time ADC TAC 2 data ");
	histogram *hTAC3 = new histogram( alim, blim, "h time ADC TAC 3 data ");

	histogram *hTAC2fs = new  histogram( 2810.0, 2830.0, "h TAC 2 fine scale for pulser data ");
	histogram *hTAC3fs = new  histogram( 2815.0, 2835.0, "h TAC 3 fine scale for pulser data ");

	 alim=0.0; blim=400.;
	 histogram *hADC1 = new histogram(alim, blim, "h ph ADC 1 data ");
	 histogram *hADC2 = new histogram(alim, blim, "h ph ADC 2 data ");


	//cout << "Enter Run Description parameters: " << endl;
	//cout <<"runNumber  pulserDelay  pulserPeriod " << endl;
	//cin >> runNumber >> pulserDelay >> pulserPeriod;


	ifstream in("inTUP");
	if ( !in ) {
		cout << "Cannot open input file. Exit with error. \n";
     		return 1;
   	}



	// 1st line is text not data
	getline(in,titleString);
	fileLineCount++;
	
	cout << "Title: " << titleString << endl;
	cout << "DEBUG:\tLine\tlineID\thdata\tddata" << endl;

   // open an output stream to make file of ascii nutples for ROOT
   ofstream nout("newTUPout");
   if(!nout)
   {
     cout << "Cannot open output file.\n";
     return 1;
   }
	// output column names
	nout <<  "adc1" << " " << "adc2" << " " << tac1 << " " << tac2 << " " << tac3 <<endl;

   for (;;) {

	in >>       adc1 >> adc2 >> tac1 >> tac2 >> tac3;

	// detect an EOF
        if ( in.eof() != 0 ) {
                cout << "Found end of file..." << endl;
                break;
        }
	ntupleInCount++;
	fileLineCount++;

	hADC1->update( (float) adc1);
	hADC2->update( (float) adc2);
	// make selection on ntuple read in
		ntupleOutCount++;

   } // end of forever

	// output histograms.
	hADC1->printLong();
	hADC2->printLong();

	//hTAC1fs->printLong();
	hTAC2fs->printLong();
	hTAC3fs->printLong();

	hADC1->printLong();
	hADC2->printLong();

	cout << endl;
	cout << "fileLineCount = " << fileLineCount << endl;
	cout << "ntupleInCount     = " << ntupleInCount << endl;
	cout << "ntupleOutCount     = " << ntupleOutCount << endl;
	//cout << "ADCtime1 count/mean/stdev = " << hTAC1->get_sumIn() << TAB << hADCtime1->mean() << TAB << hTAC2->stdev() << endl;
	cout << "End of event builder and ntuple writer." << endl;
	cout << endl;

	nout.close();

	return 0;

}
